function love.load()
	snake = {
			x = 0,
			y = 0,
			length = 4,
			speed = 6, 
			direction = "right",
			tail = {} 
		}
	tick = 0 --Used for the timer
	tile_size = 32 --This is sort of explained on line 23.
end

function love.update(dt)
	tick = tick + dt
	if tick > (1 / snake.speed) then
		snake_move()
		tick = 0
	end
end

function love.draw()
	--Notice how i'm multiplying the snakes position by tile_size, The game technically happens on a 1x1 pixel scale, But it's scaled up to 32x32 (or whatever tile_size is set to) when drawn.
	love.graphics.rectangle("fill", snake.x * tile_size, snake.y * tile_size, tile_size, tile_size) --Drawing the head
	for i,v in ipairs(snake.tail) do --Drawing the tail
		love.graphics.rectangle("line", v.x * tile_size, v.y * tile_size, tile_size, tile_size)
	end
end

function snake_move()
	local nextX = snake.x
	local nextY = snake.y
	
	--Here we figure out where the snake should go next based on it's direction.
	if snake.direction == "right" then
		nextX = nextX + 1
	elseif snake.direction == "left" then
		nextX = nextX - 1
	elseif snake.direction == "down" then
		nextY = nextY + 1
	elseif snake.direction == "up" then
		nextY = nextY - 1
	end
	--At this point nextX and nextY is the snakes next position, Now you could do collision etc.
	
	--Here we update the tail, We add a segment at the snakes position each move
	snake.tail[#snake.tail + 1] = {
			x = snake.x,--Note that at this point, We haven't touched the snakes actual position, He hasn't moved yet.
			y = snake.y
		}
	if #snake.tail > snake.length then --Then if there are more tail segments than length, we remove one.
		table.remove(snake.tail, 1)
	end
	
	--Here we actually move the head
	snake.x, snake.y = nextX, nextY
end

function love.keypressed(key)
	if key == "left" then
		if snake.direction == "up" or snake.direction == "down" then --This checks if the snake is moving along the Y axis
			snake.direction = "left"
			--And we only change the direction if he IS moving along the y axis to prevent him from turning into himself.
		end
	elseif key == "right" then
		if snake.direction == "up" or snake.direction == "down" then
			snake.direction = "right"
		end
	elseif key == "up" then
		if snake.direction == "left" or snake.direction == "right" then --This checks if the snake is moving along the X axis
			snake.direction = "up"
			--And we only change the direction if he IS moving along the X axis to prevent him from turning into himself.
		end
	elseif key == "down" then
		if snake.direction == "left" or snake.direction == "right" then
			snake.direction = "down"
		end
	end
	
	if key == " " then
		--This is how you make the snake longer
		snake.length = snake.length + 2
	end
end







